﻿import flash.filters.ColorMatrixFilter;

class Make_3d extends MovieClip {
	private var widget:Number = Math.PI / 180;
	private var distance:Number = 400;
	private var ox:Number = 275;
	private var oy:Number = 200;
	
	public var myX:Number;
	public var myY:Number;
	public var myZ:Number;
	
	// **** Need to create a system to work with rotation ****
	public var angleX:Number;
	public var angleY:Number;
	public var angleZ:Number;
	
	private var brightness_range:Number = 400;
	private var start_brightness:Number = 0;
	private var fade_mult:Number = 1;
	
	
	public function Make_3d() {
		
		myX = this._x;
		myY = this._y;
		myZ = 0;

	}
	
	public function setOrigin( origin_x:Number, origin_y:Number ):Void {
		ox = origin_x;
		oy = origin_y;
	}
	
	// Move a clip in 3d space
	public function translate_3d( x:Number, y:Number, z:Number ):Void {
		myX += x;
		myY += y;
		myZ += z;
		renderPoint();
	};
	
	// Position a clip in 3d space
	public function position_3d( x:Number, y:Number, z:Number ):Void {
		myX = x;
		myY = y;
		myZ = z;
		renderPoint();
	};
		
	// Rotate a clip around the origin
	public function rotate_3d( x:Number, y:Number, z:Number ):Void {
		var aSin = Math.sin( x * widget );
		var aCos = Math.cos( x * widget );
		var bSin = Math.sin( y * widget );
		var bCos = Math.cos( y * widget );
		var cSin = Math.sin( z * widget );
		var cCos = Math.cos( z * widget ); 
		
		var x1 = myX;
		var y1 = ( myY * aCos ) - ( myZ * aSin );
		var z1 = ( myZ * aCos ) + ( myY * aSin );
	  	// trace( "X1:" + x1 + " y1:" + y1 + " z1:" + z1 );
		var x2 = ( x1 * bCos ) - ( z1 * bSin );
		var y2 = y1;
		var z2 = ( z1 * bCos ) + ( x1 * bSin );
		// trace( "X2:" + x2 + " y2:" + y2 + " z2:" + z2 );
		var x3 = ( x2 * cCos ) - ( y2 * cSin );
		var y3 = ( y2 * cCos ) + ( x2 * cSin );
		var z3 = z2;
		// trace( "X3:" + x3 + " y3:" + y3 + " z3:" + z3 );
		myX = x3;
		myY = y3;
		myZ = z3;
		
		renderPoint();
	};
		
	
	public function renderPoint() {
		var p = distance / ( distance + myZ );
		
		set_brightness();
		
		this._x = ( myX * p ) + ox;
		this._y = ( myY * p ) + oy;
		
		this._xscale = 100 * p;
		this._yscale = 100 * p;
		this.swapDepths( 10000 - myZ  );
		// trace( this + " " + this.getDepth() );
	};
	
	private function set_brightness() {
		var b = myZ;
		if ( b > start_brightness ) {
			b = fade_mult * 100 * ( myZ - start_brightness ) / brightness_range; 
		} else {
			b = 0;
		}
		
		var brightness_array:Array = [1, 0, 0, 0, b,
									  0, 1, 0, 0, b,
									  0, 0, 1, 0, b,
									  0, 0, 0, 1, 0 ];
		this.filters = [ new ColorMatrixFilter( brightness_array ) ];
	}
	
	public function set_fade_distance( fade_dist:Number, start_dist:Number, fade_to_black:Boolean ):Void {
		start_brightness = start_dist;
		brightness_range = fade_dist;
		if ( fade_to_black ) {
			fade_mult = -1;
		} else {
			fade_mult = 1;
		}
	}
	
	public function set_camera_distance( d:Number ):Void {
		distance = d;
	}
	
}


