﻿class Make_3d extends MovieClip {
	public var myX;
	public var myY;
	public var myZ;
	private var widget = Math.PI / 180;
	
	// Constructor
	public function Make_3d() {
		this.myX = 0;
		this.myY = 0;
		this.myZ = 0;
		this.renderPoint();
	}
		
	public function transform_xyz( newX, newY, newZ ) {
		this.myX += newX;
		this.myY += newY;
		this.myZ += newZ;
		this.renderPoint();
	};
	
	public function transform_abs( newX, newY, newZ ) {
		this.myX = newX;
		this.myY = newY;
		this.myZ = newZ;
		this.renderPoint();
	};
	
	
	public function rotate( newX, newY, newZ ) {
		var aSin = Math.sin( newX * widget );
		var aCos = Math.cos( newX * widget );
		var bSin = Math.sin( newY * widget );
		var bCos = Math.cos( newY * widget );
		var cSin = Math.sin( newZ * widget );
		var cCos = Math.cos( newZ * widget ); 
	  
		var x1 = this.myX;
		var y1 = ( this.myY * aCos ) - ( this.myZ * aSin );
		var z1 = ( this.myZ * aCos ) + ( this.myY * aSin );
	  // trace( "X1:" + x1 + " y1:" + y1 + " z1:" + z1 );
		var x2 = ( x1 * bCos ) - ( z1 * bSin );
		var y2 = y1;
		var z2 = ( z1 * bCos ) + ( x1 * bSin );
		// trace( "X2:" + x2 + " y2:" + y2 + " z2:" + z2 );
		var x3 = ( x2 * cCos ) - ( y2 * cSin );
		var y3 = ( y2 * cCos ) + ( x2 * cSin );
		var z3 = z2;
	  	// trace( "X3:" + x3 + " y3:" + y3 + " z3:" + z3 );
		this.myX = x3;
		this.myY = y3;
		this.myZ = z3;
		
		this.renderPoint();
	}
	
	public function renderPoint() {
		var p = this._parent.distance / ( this._parent.distance + this.myZ );
		
		this._x = ( this.myX * p ) + this._parent.ox;
		this._y = ( this.myY * p ) + this._parent.oy;
		
		/*
		// { ra: 0, rb: 0, ga: 0, gb: 0, ba: 0, bb: 0, aa: 0, ab: 0 }
		var color_offset = Math.round( this.myZ );
		this.my_transform.rb = color_offset;
		this.my_transform.gb = color_offset;
		this.my_transform.bb = color_offset;
		
		this.my_color.setTransform( this.my_transform );
		*/
		
		this._xscale = 100 * p;
		this._yscale = 100 * p;
		// this.swapDepths( 2000000 - ( this.n + ( this.myZ * object_count ) ) );
		this.swapDepths( 2000000 - this.myZ );
		
	};
};

